/**
 * This work was created by participants in the DataONE project, and is
 * jointly copyrighted by participating institutions in DataONE. For
 * more information on DataONE, see our web site at http://dataone.org.
 *
 *   Copyright 2014
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.dataone.tidy.dao;

import java.text.ParseException;
import java.util.Map;

import org.dataone.cn.dao.SystemMetadataDaoMetacatImpl;
import org.dataone.cn.dao.SystemMetadataDaoMetacatImplTestUtil;
import org.dataone.service.types.v1.NodeReference;
import org.dataone.service.types.v1.SystemMetadata;
import org.springframework.jdbc.core.JdbcTemplate;

public class SystemMetadataTidyDaoImplUtil {

    public void createTables(JdbcTemplate jdbc) {
        SystemMetadataDaoMetacatImplTestUtil.createTables(jdbc,
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.createTables(jdbc,
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.createTables(jdbc,
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.createTables(jdbc,
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

    }

    public void dropTables(JdbcTemplate jdbc) {
        SystemMetadataDaoMetacatImplTestUtil.dropTables(jdbc, SystemMetadataTidyDaoImpl.orcTableMap
                .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.dropTables(jdbc,
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.dropTables(
                jdbc, //
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.dropTables(
                jdbc, //
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.mergedTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));
    }

    public void populateAllMergeSourceTablesWithTestA(JdbcTemplate jdbc) {
        SystemMetadataDaoMetacatImplTestUtil.populateTablesWithTestA(jdbc,
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.orcTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.populateTablesWithTestA(jdbc,
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.ucsbTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));

        SystemMetadataDaoMetacatImplTestUtil.populateTablesWithTestA(jdbc,
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.IDENTIFIER_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SYSMETA_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_POLICY_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.SM_STATUS_TABLE),
                SystemMetadataTidyDaoImpl.unmTableMap
                        .get(SystemMetadataDaoMetacatImpl.ACCESS_TABLE));
    }

    public void verifyAllSourceTestA(Map<NodeReference, SystemMetadata> smdMap)
            throws ParseException {
        for (SystemMetadata sysMeta : smdMap.values()) {
            SystemMetadataDaoMetacatImplTestUtil.verifyTestA(sysMeta);
        }
    }

    public void populateAllMergeSourceTablesWithSystemMetadata(JdbcTemplate jdbc, SystemMetadata smd) {
    }
}
